Fixing typo
[apex.git] / lib / overcloud-deploy-functions.sh
1 #!/usr/bin/env bash
2 ##############################################################################
3 # Copyright (c) 2015 Tim Rozet (Red Hat), Dan Radez (Red Hat) and others.
4 #
5 # All rights reserved. This program and the accompanying materials
6 # are made available under the terms of the Apache License, Version 2.0
7 # which accompanies this distribution, and is available at
8 # http://www.apache.org/licenses/LICENSE-2.0
9 ##############################################################################
10
11 ##preping it for deployment and launch the deploy
12 ##params: none
13 function overcloud_deploy {
14   local num_compute_nodes
15   local num_control_nodes
16
17   if [[ "${#deploy_options_array[@]}" -eq 0 || "${deploy_options_array['sdn_controller']}" == 'opendaylight' ]]; then
18     if [ "${deploy_options_array['sfc']}" == 'True' ]; then
19       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/opendaylight_sfc.yaml"
20     elif [ "${deploy_options_array['vpn']}" == 'True' ]; then
21       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/opendaylight_sdnvpn.yaml"
22     elif [ "${deploy_options_array['vpp']}" == 'True' ]; then
23       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/opendaylight_fdio.yaml"
24     elif [ "${deploy_options_array['vpn']}" == 'true' ]; then
25       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/opendaylight_sdnvpn.yaml"
26     else
27       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/neutron-opendaylight-l3.yaml"
28     fi
29     SDN_IMAGE=opendaylight
30   elif [ "${deploy_options_array['sdn_controller']}" == 'opendaylight-external' ]; then
31     DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/opendaylight-external.yaml"
32     SDN_IMAGE=opendaylight
33   elif [ "${deploy_options_array['sdn_controller']}" == 'onos' ]; then
34     if [ "${deploy_options_array['sfc']}" == 'True' ]; then
35       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/onos_sfc.yaml"
36     else
37       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/onos.yaml"
38     fi
39     SDN_IMAGE=onos
40   elif [ "${deploy_options_array['sdn_controller']}" == 'opencontrail' ]; then
41     echo -e "${red}ERROR: OpenContrail is currently unsupported...exiting${reset}"
42     exit 1
43   elif [[ -z "${deploy_options_array['sdn_controller']}" || "${deploy_options_array['sdn_controller']}" == 'False' ]]; then
44     echo -e "${blue}INFO: SDN Controller disabled...will deploy nosdn scenario${reset}"
45     if [ "${deploy_options_array['vpp']}" == 'True' ]; then
46       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/neutron-ml2-networking-vpp.yaml"
47     fi
48     SDN_IMAGE=opendaylight
49   else
50     echo "${red}Invalid sdn_controller: ${deploy_options_array['sdn_controller']}${reset}"
51     echo "${red}Valid choices are opendaylight, opendaylight-external, onos, opencontrail, False, or null${reset}"
52     exit 1
53   fi
54
55
56
57   # Make sure the correct overcloud image is available
58   if [ ! -f $IMAGES/overcloud-full-${SDN_IMAGE}.qcow2 ]; then
59       echo "${red} $IMAGES/overcloud-full-${SDN_IMAGE}.qcow2 is required to execute your deployment."
60       echo "Please install the opnfv-apex package to provide this overcloud image for deployment.${reset}"
61       exit 1
62   fi
63
64   echo "Copying overcloud image to Undercloud"
65   ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" "rm -f overcloud-full.qcow2"
66   scp ${SSH_OPTIONS[@]} $IMAGES/overcloud-full-${SDN_IMAGE}.qcow2 "stack@$UNDERCLOUD":overcloud-full.qcow2
67
68   # Install ovs-dpdk inside the overcloud image if it is enabled.
69   if [[ "${deploy_options_array['dataplane']}" == 'ovs_dpdk' || "${deploy_options_array['dataplane']}" == 'fdio' ]]; then
70     # install dpdk packages before ovs
71     echo -e "${blue}INFO: Enabling kernel modules for dpdk inside overcloud image${reset}"
72
73     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
74       cat << EOF > vfio_pci.modules
75 #!/bin/bash
76 exec /sbin/modprobe vfio_pci >/dev/null 2>&1
77 EOF
78
79       cat << EOF > uio_pci_generic.modules
80 #!/bin/bash
81 exec /sbin/modprobe uio_pci_generic >/dev/null 2>&1
82 EOF
83
84       LIBGUESTFS_BACKEND=direct virt-customize --upload vfio_pci.modules:/etc/sysconfig/modules/ \
85                                                --upload uio_pci_generic.modules:/etc/sysconfig/modules/ \
86                                                --run-command "chmod 0755 /etc/sysconfig/modules/vfio_pci.modules" \
87                                                --run-command "chmod 0755 /etc/sysconfig/modules/uio_pci_generic.modules" \
88                                                -a overcloud-full.qcow2
89
90       if [ "${deploy_options_array['dataplane']}" == 'fdio' ]; then
91         sudo sed -i '/FdioEnabled:/c\  FdioEnabled: true' /usr/share/openstack-tripleo-heat-templates/environments/numa.yaml
92         LIBGUESTFS_BACKEND=direct virt-customize --run-command "cp -f /root/fdio_neutron_l3/namespaces.py /usr/lib/python2.7/site-packages/neutron/agent/l3/" \
93                                                  --run-command "cp -f /root/fdio_neutron_l3/router_info.py /usr/lib/python2.7/site-packages/neutron/agent/l3/" \
94                                                  -a overcloud-full.qcow2
95         if [ "${deploy_options_array['sdn_controller']}" == 'opendaylight' ]; then
96           LIBGUESTFS_BACKEND=direct virt-customize --run-command "cd /root/ && tar zxvf networking-odl.tar.gz" \
97                                                    --run-command "cd /root/networking-odl && git init && pip install -r requirements.txt" \
98                                                    --run-command "cd /root/networking-odl && python setup.py build && python setup.py install" \
99                                                    -a overcloud-full.qcow2
100         fi
101       else
102         sudo sed -i '/NeutronOVSDataPathType:/c\  NeutronOVSDataPathType: netdev' /usr/share/openstack-tripleo-heat-templates/environments/numa.yaml
103         LIBGUESTFS_BACKEND=direct virt-customize --run-command "yum install -y /root/dpdk_rpms/*" \
104                                                  --run-command "sed -i '/RuntimeDirectoryMode=.*/d' /usr/lib/systemd/system/openvswitch-nonetwork.service" \
105                                                  --run-command "printf \"%s\\n\" RuntimeDirectoryMode=0775 Group=qemu UMask=0002 >> /usr/lib/systemd/system/openvswitch-nonetwork.service" \
106                                                  --run-command "sed -i 's/\\(^\\s\\+\\)\\(start_daemon "$OVS_VSWITCHD_PRIORITY"\\)/\\1umask 0002 \\&\\& \\2/' /usr/share/openvswitch/scripts/ovs-ctl" \
107                                                  -a overcloud-full.qcow2
108       fi
109
110 EOI
111
112   elif [ "${deploy_options_array['dataplane']}" != 'ovs' ]; then
113     echo "${red}${deploy_options_array['dataplane']} not supported${reset}"
114     exit 1
115   fi
116
117   if [ "$debug" == 'TRUE' ]; then
118     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" "LIBGUESTFS_BACKEND=direct virt-customize -a overcloud-full.qcow2 --root-password password:opnfvapex"
119   fi
120
121   # upgrade ovs into ovs 2.5.90 with NSH function if SFC is enabled
122   if [[ "${deploy_options_array['sfc']}" == 'True' && "${deploy_options_array['dataplane']}" == 'ovs' ]]; then
123     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
124          LIBGUESTFS_BACKEND=direct virt-customize --run-command "yum install -y /root/ovs/rpm/rpmbuild/RPMS/x86_64/${ovs_kmod_rpm_name}" \
125                                                   --run-command "yum upgrade -y /root/ovs/rpm/rpmbuild/RPMS/x86_64/${ovs_rpm_name}" \
126                                                   -a overcloud-full.qcow2
127 EOI
128   fi
129
130   # Set ODL version accordingly
131   if [[ "${deploy_options_array['sdn_controller']}" == 'opendaylight' && -n "${deploy_options_array['odl_version']}" ]]; then
132     case "${deploy_options_array['odl_version']}" in
133       beryllium) odl_version=''
134               ;;
135       boron)  odl_version='boron'
136               ;;
137       carbon) odl_version='master'
138               ;;
139       *) echo -e "${red}Invalid ODL version ${deploy_options_array['odl_version']}.  Please use 'carbon' or 'boron' values.${reset}"
140          exit 1
141          ;;
142     esac
143
144     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
145       LIBGUESTFS_BACKEND=direct virt-customize --run-command "yum -y remove opendaylight" \
146                                                --run-command "yum -y install /root/${odl_version}/*" \
147                                                -a overcloud-full.qcow2
148 EOI
149   fi
150
151   # Add performance deploy options if they have been set
152   if [ ! -z "${deploy_options_array['performance']}" ]; then
153
154     # Remove previous kernel args files per role
155     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" "rm -f Compute-kernel_params.txt"
156     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" "rm -f Controller-kernel_params.txt"
157
158     # Push performance options to subscript to modify per-role images as needed
159     for option in "${performance_options[@]}" ; do
160       echo -e "${blue}Setting performance option $option${reset}"
161       ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" "dataplane=${deploy_options_array['dataplane']} bash build_perf_image.sh $option"
162     done
163
164     # Build IPA kernel option ramdisks
165     ssh -T ${SSH_OPTIONS[@]} "root@$UNDERCLOUD" <<EOI
166 /bin/cp -f /home/stack/ironic-python-agent.initramfs /root/
167 mkdir -p ipa/
168 pushd ipa
169 gunzip -c ../ironic-python-agent.initramfs | cpio -i
170 if [ ! -f /home/stack/Compute-kernel_params.txt ]; then
171   touch /home/stack/Compute-kernel_params.txt
172   chown stack /home/stack/Compute-kernel_params.txt
173 fi
174 /bin/cp -f /home/stack/Compute-kernel_params.txt tmp/kernel_params.txt
175 echo "Compute params set: "
176 cat tmp/kernel_params.txt
177 /bin/cp -f /root/image.py usr/lib/python2.7/site-packages/ironic_python_agent/extensions/image.py
178 /bin/cp -f /root/image.pyc usr/lib/python2.7/site-packages/ironic_python_agent/extensions/image.pyc
179 find . | cpio -o -H newc | gzip > /home/stack/Compute-ironic-python-agent.initramfs
180 chown stack /home/stack/Compute-ironic-python-agent.initramfs
181 if [ ! -f /home/stack/Controller-kernel_params.txt ]; then
182   touch /home/stack/Controller-kernel_params.txt
183   chown stack /home/stack/Controller-kernel_params.txt
184 fi
185 /bin/cp -f /home/stack/Controller-kernel_params.txt tmp/kernel_params.txt
186 echo "Controller params set: "
187 cat tmp/kernel_params.txt
188 find . | cpio -o -H newc | gzip > /home/stack/Controller-ironic-python-agent.initramfs
189 chown stack /home/stack/Controller-ironic-python-agent.initramfs
190 popd
191 /bin/rm -rf ipa/
192 EOI
193
194     # set NIC heat params and resource registry
195     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
196 if [ -n "${private_network_compute_interface}" ]; then
197   sudo sed -i '/ComputeTenantNIC:/c\  ComputeTenantNIC: '${private_network_compute_interface} /usr/share/openstack-tripleo-heat-templates/environments/numa.yaml
198 fi
199 if [ -n "${private_network_controller_interface}" ]; then
200   sudo sed -i '/ControllerTenantNIC:/c\  ControllerTenantNIC: '${private_network_controller_interface} /usr/share/openstack-tripleo-heat-templates/environments/numa.yaml
201 fi
202 # TODO: PublicNIC is not used today, however, in the future, we'll bind public nic to DPDK as well for certain scenarios. At that time,
203 # we'll need to make sure public network is enabled.
204 if [ -n "${public_network_compute_interface}" ]; then
205   sudo sed -i '/ComputePublicNIC:/c\  ComputePublicNIC: '${public_network_compute_interface} /usr/share/openstack-tripleo-heat-templates/environments/numa.yaml
206 fi
207 if [ -n "${public_network_controller_interface}" ]; then
208   sudo sed -i '/ControllerPublicNIC:/c\  ControllerPublicNIC: '${public_network_controller_interface} /usr/share/openstack-tripleo-heat-templates/environments/numa.yaml
209 fi
210 EOI
211
212     echo -e "${blue}INFO: Including /usr/share/openstack-tripleo-heat-templates/environments/numa.yaml ${reset}"
213     if [ "$debug" == 'TRUE' ]; then
214       ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" "cat /usr/share/openstack-tripleo-heat-templates/environments/numa.yaml"
215     fi
216     DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/numa.yaml"
217   fi
218
219   # check if ceph should be enabled
220   if [ "${deploy_options_array['ceph']}" == 'True' ]; then
221     DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/storage-environment.yaml"
222   fi
223
224   #DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/network-isolation.yaml"
225   DEPLOY_OPTIONS+=" -e network-environment.yaml"
226
227
228   # get number of nodes available in inventory
229   num_control_nodes=$(ssh -T ${SSH_OPTIONS[@]} "root@$UNDERCLOUD" "grep -c profile:control /home/stack/instackenv.json")
230   num_compute_nodes=$(ssh -T ${SSH_OPTIONS[@]} "root@$UNDERCLOUD" "grep -c profile:compute /home/stack/instackenv.json")
231
232   # check if HA is enabled
233   if [[ "$ha_enabled" == "True" ]]; then
234     if [ "$num_control_nodes" -lt 3 ]; then
235       echo -e "${red}ERROR: Number of control nodes in inventory is less than 3 and HA is enabled: ${num_control_nodes}. Check your inventory file.${reset}"
236       exit 1
237     else
238      DEPLOY_OPTIONS+=" --control-scale ${num_control_nodes}"
239      DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/puppet-pacemaker.yaml"
240      echo -e "${blue}INFO: Number of control nodes set for deployment: ${num_control_nodes}${reset}"
241     fi
242   else
243     if [ "$num_control_nodes" -lt 1 ]; then
244       echo -e "${red}ERROR: Number of control nodes in inventory is less than 1: ${num_control_nodes}. Check your inventory file.${reset}"
245       exit 1
246     fi
247   fi
248
249   if [ "$num_compute_nodes" -le 0 ]; then
250     echo -e "${red}ERROR: Invalid number of compute nodes: ${num_compute_nodes}. Check your inventory file.${reset}"
251     exit 1
252   else
253     echo -e "${blue}INFO: Number of compute nodes set for deployment: ${num_compute_nodes}${reset}"
254     DEPLOY_OPTIONS+=" --compute-scale ${num_compute_nodes}"
255   fi
256
257   DEPLOY_OPTIONS+=" --ntp-server $ntp_server"
258
259   DEPLOY_OPTIONS+=" --control-flavor control --compute-flavor compute"
260   if [[ "$virtual" == "TRUE" ]]; then
261      DEPLOY_OPTIONS+=" -e virtual-environment.yaml"
262   fi
263
264   DEPLOY_OPTIONS+=" -e ${ENV_FILE}"
265
266   echo -e "${blue}INFO: Deploy options set:\n${DEPLOY_OPTIONS}${reset}"
267
268   ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
269 if [ "${deploy_options_array['tacker']}" == 'False' ]; then
270     sed -i '/EnableTacker:/c\  EnableTacker: false' ${ENV_FILE}
271 fi
272
273 # Create a key for use by nova for live migration
274 echo "Creating nova SSH key for nova resize support"
275 ssh-keygen -f nova_id_rsa -b 1024 -P ""
276 public_key=\'\$(cat nova_id_rsa.pub | cut -d ' ' -f 2)\'
277 sed -i "s#replace_public_key:#key: \$public_key#g" ${ENV_FILE}
278 python -c 'open("opnfv-environment-new.yaml", "w").write((open("${ENV_FILE}").read().replace("replace_private_key:", "key: \"" + "".join(open("nova_id_rsa").readlines()).replace("\\n","\\\n") + "\"")))'
279 mv -f opnfv-environment-new.yaml ${ENV_FILE}
280
281 source stackrc
282 set -o errexit
283 # Workaround for APEX-207 where sometimes swift proxy is down
284 if ! sudo systemctl status openstack-swift-proxy > /dev/null; then
285   sudo systemctl restart openstack-swift-proxy
286 fi
287 echo "Uploading overcloud glance images"
288 openstack overcloud image upload
289
290 echo "Configuring undercloud and discovering nodes"
291 openstack baremetal import --json instackenv.json
292
293 bash -x set_perf_images.sh ${performance_roles[@]}
294 if [[ -z "$virtual" ]]; then
295   openstack baremetal introspection bulk start
296   if [[ -n "$root_disk_list" ]]; then
297     openstack baremetal configure boot --root-device=${root_disk_list}
298   else
299     openstack baremetal configure boot
300   fi
301 else
302   openstack baremetal configure boot
303 fi
304
305 echo "Configuring flavors"
306 for flavor in baremetal control compute; do
307   echo -e "${blue}INFO: Updating flavor: \${flavor}${reset}"
308   if openstack flavor list | grep \${flavor}; then
309     openstack flavor delete \${flavor}
310   fi
311   openstack flavor create --id auto --ram 4096 --disk 39 --vcpus 1 \${flavor}
312   if ! openstack flavor list | grep \${flavor}; then
313     echo -e "${red}ERROR: Unable to create flavor \${flavor}${reset}"
314   fi
315 done
316 openstack flavor set --property "cpu_arch"="x86_64" --property "capabilities:boot_option"="local" baremetal
317 openstack flavor set --property "cpu_arch"="x86_64" --property "capabilities:boot_option"="local" --property "capabilities:profile"="control" control
318 openstack flavor set --property "cpu_arch"="x86_64" --property "capabilities:boot_option"="local" --property "capabilities:profile"="compute" compute
319 echo "Configuring nameserver on ctlplane network"
320 dns_server_ext=''
321 for dns_server in ${dns_servers}; do
322   dns_server_ext="\${dns_server_ext} --dns-nameserver \${dns_server}"
323 done
324 neutron subnet-update \$(neutron subnet-list | grep -Ev "id|tenant|external|storage" | grep -v \\\\-\\\\- | awk {'print \$2'}) \${dns_server_ext}
325 sed -i '/CloudDomain:/c\  CloudDomain: '${domain_name} ${ENV_FILE}
326 echo "Executing overcloud deployment, this should run for an extended period without output."
327 sleep 60 #wait for Hypervisor stats to check-in to nova
328 # save deploy command so it can be used for debugging
329 cat > deploy_command << EOF
330 openstack overcloud deploy --templates $DEPLOY_OPTIONS --timeout 90
331 EOF
332 EOI
333
334   if [ "$interactive" == "TRUE" ]; then
335     if ! prompt_user "Overcloud Deployment"; then
336       echo -e "${blue}INFO: User requests exit${reset}"
337       exit 0
338     fi
339   fi
340
341   ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
342 source stackrc
343 openstack overcloud deploy --templates $DEPLOY_OPTIONS --timeout 90
344 if ! openstack stack list | grep CREATE_COMPLETE 1>/dev/null; then
345   $(typeset -f debug_stack)
346   debug_stack
347   exit 1
348 fi
349 EOI
350
351   # Configure DPDK
352   if [ "${deploy_options_array['dataplane']}" == 'ovs_dpdk' ]; then
353     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI || (echo "DPDK config failed, exiting..."; exit 1)
354 source stackrc
355 set -o errexit
356 for node in \$(nova list | grep novacompute | grep -Eo "[0-9]+\.[0-9]+\.[0-9]+\.[0-9]+"); do
357 echo "Running DPDK test app on \$node"
358 ssh -T ${SSH_OPTIONS[@]} "heat-admin@\$node" <<EOF
359 set -o errexit
360 sudo dpdk_helloworld --no-pci
361 sudo dpdk_nic_bind -s
362 EOF
363 done
364 EOI
365   fi
366
367   if [ "$debug" == 'TRUE' ]; then
368       ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
369 source overcloudrc
370 echo "Keystone Endpoint List:"
371 openstack endpoint list
372 echo "Keystone Service List"
373 openstack service list
374 cinder quota-show \$(openstack project list | grep admin | awk {'print \$2'})
375 EOI
376   fi
377 }